/*
 * blanco Framework
 * Copyright (C) 2004-2009 IGA Tosiki
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.sample.jsf.proxy;

import java.io.IOException;
import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.SQLException;

import javax.el.ELContext;
import javax.el.ELResolver;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;

import blanco.sample.jsf.BlancoJsfSample1AddLogic;
import blanco.sample.jsf.BlancoJsfSample1InitializeLogic;
import blanco.sample.jsf.BlancoJsfSample1ModifyLogic;
import blanco.sample.jsf.BlancoJsfSample1ViewLogic;
import blanco.sample.jsf.db.query.SimpleBookInsertInvoker;
import blanco.sample.jsf.db.query.SimpleBookSelectIterator;
import blanco.sample.jsf.util.BlancoJsfProxyUtil;

/**
 * JSF の Managed Bean と実際の処理とをつなぐプロキシ・クラス。
 *
 * <p>faces-config.xml には以下のように登録します。</p>
 * <pre>
 * &lt;managed-bean&gt;
 * 	&lt;managed-bean-name&gt;BlancoJsfSample1Logic&lt;/managed-bean-name&gt;
 * 	&lt;managed-bean-class&gt;blanco.sample.jsf.proxy.BlancoJsfSample1LogicProxy&lt;/managed-bean-class&gt;
 * &lt;managed-bean-scope&gt;request&lt;/managed-bean-scope&gt;
 * &lt;/managed-bean&gt;
 * </pre>
 */
@SuppressWarnings("serial")
public class BlancoJsfSample1LogicProxy extends String {
    /**
     * 初期化されたかどうか。
     */
    private boolean fIsInitialized = false;

    /**
     * ページの処理結果。
     */
    private String fOutcome = "error";

    /**
     * 画面ロード時。
     *
     * @return 処理内容にかかわらず、何も戻しません。
     */
    public String getLoad() {
        if (fIsInitialized == false) {
            initialize(null);
            fIsInitialized = true;
        }
        view(null);

        return "";
    }

    /**
     * クラスをインスタンス化して処理を実行する際のエントリポイントです。
     *
     * @param actionEvent イベント。
     */
    public final void initialize(final ActionEvent actionEvent) {
        // 以下のコードでコンパイル・エラーが発生する場合には、クラス [blanco.sample.jsf.BlancoJsfSample1InitializeLogicImpl] を新規に作成してください。
        final BlancoJsfSample1InitializeLogic logic = new blanco.sample.jsf.BlancoJsfSample1InitializeLogicImpl();

        try {
            logic.execute(this);
        } catch (IllegalArgumentException ex) {
            BlancoJsfProxyUtil.logIllegalArgumentException("画面ID.メソッド", ex);
        } catch (IOException ex) {
            BlancoJsfProxyUtil.logIOException("画面ID.メソッド", ex);
        } catch (Exception ex) {
            BlancoJsfProxyUtil.logException("画面ID.メソッド", ex);
        }
    }

    /**
     * クラスをインスタンス化して処理を実行する際のエントリポイントです。
     *
     * @param actionEvent イベント。
     */
    public final void view(final ActionEvent actionEvent) {
        // 以下のコードでコンパイル・エラーが発生する場合には、クラス [blanco.sample.jsf.BlancoJsfSample1ViewLogicImpl] を新規に作成してください。
        final BlancoJsfSample1ViewLogic logic = new blanco.sample.jsf.BlancoJsfSample1ViewLogicImpl();

        try {
            logic.execute(this);
        } catch (IllegalArgumentException ex) {
            BlancoJsfProxyUtil.logIllegalArgumentException("画面ID.メソッド", ex);
        } catch (IOException ex) {
            BlancoJsfProxyUtil.logIOException("画面ID.メソッド", ex);
        } catch (Exception ex) {
            BlancoJsfProxyUtil.logException("画面ID.メソッド", ex);
        }
    }

    /**
     * クラスをインスタンス化して処理を実行する際のエントリポイントです。
     *
     * @param actionEvent イベント。
     */
    public final void add(final ActionEvent actionEvent) {
        final FacesContext ctx = FacesContext.getCurrentInstance();
        final ELContext elc = ctx.getELContext();
        final ELResolver rslvr = ctx.getApplication().getELResolver();

        // session から Managed Bean [integer] を取得します。
        final Integer argInteger = (Integer) rslvr.getValue(elc, null, "integer");
        // session から Managed Bean [blancoJsfSample2Logic] を取得します。
        final String argString = (String) rslvr.getValue(elc, null, "blancoJsfSample2Logic");

        final Connection conn = BlancoJsfProxyUtil.getConnection();
        boolean isLogicSuccess = false;
        final SimpleBookSelectIterator argSimpleBookSelectIterator = new SimpleBookSelectIterator(conn);
        final SimpleBookInsertInvoker argSimpleBookInsertInvoker = new SimpleBookInsertInvoker(conn);

        // 以下のコードでコンパイル・エラーが発生する場合には、クラス [blanco.sample.jsf.BlancoJsfSample1AddLogicImpl] を新規に作成してください。
        final BlancoJsfSample1AddLogic logic = new blanco.sample.jsf.BlancoJsfSample1AddLogicImpl();

        try {
            fOutcome = "error";
            final String outcome = logic.execute(this, argInteger, argString, argSimpleBookSelectIterator, argSimpleBookInsertInvoker, conn);

            conn.commit();
            isLogicSuccess = true;
            fOutcome = outcome;
            argSimpleBookSelectIterator.close();
            argSimpleBookInsertInvoker.close();
        } catch (IllegalArgumentException ex) {
            BlancoJsfProxyUtil.logIllegalArgumentException("画面ID.メソッド", ex);
        } catch (IOException ex) {
            BlancoJsfProxyUtil.logIOException("画面ID.メソッド", ex);
        } catch (SQLException ex) {
            BlancoJsfProxyUtil.logSQLException("画面ID.メソッド", ex);
        } catch (Exception ex) {
            BlancoJsfProxyUtil.logException("画面ID.メソッド", ex);
        }

        if (isLogicSuccess == false) {
            try {
                conn.rollback();
            } catch (Exception ex) {
                ex.printStackTrace();
            }
        }
        // コネクションの開放。
        BlancoJsfProxyUtil.releaseConnection(conn);
    }

    /**
     * クラスをインスタンス化して処理を実行する際のエントリポイントです。
     *
     * @param actionEvent イベント。
     */
    public final void modify(final ActionEvent actionEvent) {
        final FacesContext ctx = FacesContext.getCurrentInstance();
        final ELContext elc = ctx.getELContext();
        final ELResolver rslvr = ctx.getApplication().getELResolver();

        // session から Managed Bean [bigDecimal] を取得します。
        final BigDecimal argBigDecimal = (BigDecimal) rslvr.getValue(elc, null, "bigDecimal");
        // session から Managed Bean [integer] を取得します。
        final Integer argInteger = (Integer) rslvr.getValue(elc, null, "integer");

        final Connection conn = BlancoJsfProxyUtil.getConnection();
        boolean isLogicSuccess = false;
        final SimpleBookSelectIterator argSimpleBookSelectIterator = new SimpleBookSelectIterator(conn);

        // 以下のコードでコンパイル・エラーが発生する場合には、クラス [blanco.sample.jsf.BlancoJsfSample1ModifyLogicImpl] を新規に作成してください。
        final BlancoJsfSample1ModifyLogic logic = new blanco.sample.jsf.BlancoJsfSample1ModifyLogicImpl();

        try {
            logic.execute(this, argBigDecimal, argInteger, argSimpleBookSelectIterator, conn, actionEvent);

            conn.commit();
            isLogicSuccess = true;
            argSimpleBookSelectIterator.close();
        } catch (IllegalArgumentException ex) {
            BlancoJsfProxyUtil.logIllegalArgumentException("画面ID.メソッド", ex);
        } catch (IOException ex) {
            BlancoJsfProxyUtil.logIOException("画面ID.メソッド", ex);
        } catch (SQLException ex) {
            BlancoJsfProxyUtil.logSQLException("画面ID.メソッド", ex);
        } catch (Exception ex) {
            BlancoJsfProxyUtil.logException("画面ID.メソッド", ex);
        }

        if (isLogicSuccess == false) {
            try {
                conn.rollback();
            } catch (Exception ex) {
                ex.printStackTrace();
            }
        }
        // コネクションの開放。
        BlancoJsfProxyUtil.releaseConnection(conn);
    }

    /**
     * 実行結果を取得。
     *
     * @return 次画面情報。
     */
    public final String outcome() {
        return fOutcome;
    }
}
